#***********************************************************************
# Licensed Material - Property of IBM
#
# 5724-R31, 5655-S30
#
# (c) Copyright IBM Corp. 2009,2010,2011.  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#************************************************************************
##################################################################
#
# Uninstalls Telecom ICP ears.
#
# #######################################################################
import sys
import java
#########################################################################
# Load properties from file
#########################################################################
print
print "Reading configuration properties ..."
from java.util import Properties
from java.io import FileInputStream
from java.io import FileOutputStream
from java.io import OutputStreamWriter
from java.lang import System
from java.lang import Boolean
from java.lang import Integer
from java.lang import String
from com.ibm.wbimonitor.lifecycle.spi.mbeans import RESTSecurityAdminMBeanFactory

propFile = "config.properties"
fis = FileInputStream(propFile)
prop = Properties()
prop.load(fis)
print prop

#########################################################################
# Get Derby DB DSN properties
#########################################################################
jndiName = prop.getProperty('jndiName')
wicpDatabaseName = prop.getProperty('wicpDatabaseName')
wicpDbHostName = prop.getProperty('wicpDbHostName')
wicpDbUser = prop.getProperty('wicpDbUser')
wicpDbPassword = prop.getProperty('wicpDbPassword')

#########################################################################
# Get Monitor Model and ear properties
#########################################################################
print
print "Loading Monitor Model configurations ..."
mmAppName = prop.getProperty('mmAppName')
mmEarFileName = prop.getProperty('mmEarFileName')

refEarAppNameOrder_TOCP_IPMP = prop.getProperty('refEarAppNameOrder_TOCP_IPMP')
refEarFileNameOrder_TOCP_IPMP = prop.getProperty('refEarFileNameOrder_TOCP_IPMP')

refEarAppNameOrder_TOCP_IPMMS = prop.getProperty('refEarAppNameOrder_TOCP_IPMMS')
refEarFileNameOrder_TOCP_IPMMS = prop.getProperty('refEarFileNameOrder_TOCP_IPMMS')

print "Configuration properties loaded."
#########################################################################
# Get User and Group properties
#########################################################################
print
print "Loading User and Group configurations ..."
groupName_CSR = prop.getProperty('groupName_CSR')
userName01 = prop.getProperty('userName01')
surName01 = prop.getProperty('surName01')
groupName_Manager = prop.getProperty('groupName_Manager')
userName02 = prop.getProperty('userName02')
surName02 = prop.getProperty('surName02')
#########################################################################
# Get connected cell/node/server name
#########################################################################
print
print "Reading server configuration ..."
cell = AdminControl.getCell();
print cell
node = AdminControl.getNode();
print node
wsadminServer =AdminControl.queryNames("node=" + node + ",type=Server,*" )
server = AdminControl.getAttribute(wsadminServer, "name" )
print server
#######################################################################
#
#
#########################################################################
# Get CEI configuration options
#########################################################################
print
print "Loading CEI configurations ..."

serverLocation = prop.getProperty('serverLocation')
hostName = prop.getProperty('hostName')
rmiPort = prop.getProperty('rmiPort')
soapPort = prop.getProperty('soapPort')
securityMode = prop.getProperty('securityMode')
userid = prop.getProperty('userid')
password = prop.getProperty('password')
eventGroup = prop.getProperty('eventGroup')
cellName = prop.getProperty('cellName')
nodeName = prop.getProperty('nodeName')
serverName = prop.getProperty('serverName')
clusterName = prop.getProperty('clusterName')
distributionMode = prop.getProperty('distributionMode')

#######################################################################
# Def - Uninstalling the Existing Application
#######################################################################

def unInstallApplications(appList):
    installedApps = AdminApp.list().splitlines()
    try:
        for app in appList:
            if(app in installedApps):
                print "Uninstalling "+ app
                AdminApp.uninstall(app)
		AdminConfig.save()
    except:
        print "Exception:Error while uninstalling "+ app
        sys.stderr.write("Exception:Error while uninstalling "+ app)
        raise
AdminConfig.save()
print "The order is: "     
fabricApplicationList = [refEarAppNameOrder_TOCP_IPMP, refEarAppNameOrder_TOCP_IPMMS, mmAppName]
print "The List of uninstallable: " + str(fabricApplicationList)
unInstallApplications(fabricApplicationList)
#########################################################################
# Deleting users, groups and their mapping
#########################################################################
print
print "Deleting users, groups and their mapping ..."
try :
	attrName1 = ["-uid",userName01]
	if(len(AdminTask.searchUsers(attrName1)) > 1):
	    print "Deleting user " +  userName01
	    userStr1 =  AdminTask.searchUsers(attrName1)
	    attrGrp = ["-cn",groupName_CSR]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr1,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member "  +  userName01 + " from group"
	    appOptions = ["-uniqueName", userStr1]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName01
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupName_CSR
	    
	else :
	    print "User " + userName01 + " does not exist" 

	attrName2 = ["-uid",userName02]
	if(len(AdminTask.searchUsers(attrName2)) > 1):
	    print "Deleting user " +  userName02
	    userStr7 =  AdminTask.searchUsers(attrName2)
	    attrGrp = ["-cn",groupName_Manager]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr7,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member " + userName02 + " from group"
	    appOptions = ["-uniqueName", userStr7]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName02
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupName_Manager
	else :
	    print "User " + userName02 + " does not exist"

except :
        print "Exception:Error occured while deleting users, groups and their mapping "
        sys.stderr.write("Error occured while deleting users, groups and their mapping ")
        raise

	#########################################################################
# Monitor Model Role Mapping removal begins.
#########################################################################

AdminControl.trace( 'com.ibm.wbimonitor.*=all=enabled' )  

rest_mbean = RESTSecurityAdminMBeanFactory.getMBean( AdminControl.getAdminClient() )
print 'RESTSecurityAdminMBean.toString=' + rest_mbean.toString()

#The return type is a boolean 'true' or 'false'


result = rest_mbean.removeRole("uid="+userName02+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName02 + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName02 + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName02+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02 + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02 + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName02+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02 + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02 + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName02+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02 + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02 + "to role KPI-Administrator"

#########################################################################
# Monitor Model Role Mapping removed.
#########################################################################

#########################################################################
# Removing Datasource
#########################################################################

##########################################################
#Get Datasources based on JNDIname and scope.
##########################################################
def findDataSource(jndiName,scopeId,scope):

    dataSourceList = AdminConfig.list("DataSource", scopeId).split(lineSeparator)
    for dsentry in dataSourceList :
        dsJndiName = AdminConfig.showAttribute(dsentry,"jndiName")
        if(dsJndiName == jndiName) :
	        provider = AdminConfig.showAttribute(dsentry,"provider")
	        provideName = AdminConfig.showAttribute(provider,"name")
	        dataSourceName = AdminConfig.showAttribute(dsentry,"name")
	        path = scope + "JDBCProvider:"+ provideName + "/DataSource:" + dataSourceName+"/"
	        dataSource = AdminConfig.getid(path)
	        if(dataSource != "") :
	            return dataSource
    return ""

###################################################################
# Command line parameters passed in. Evaluate each of these paramters
###################################################################

nextArg = 0;
while(len(sys.argv) > nextArg) :
    param = sys.argv[nextArg]
    nextArg +=1
    value = sys.argv[nextArg]
    nextArg +=1
    if (param == "-nodeName"):
        nodeName = value
    elif (param == "-cellName"):
        cellName = value

nodeId=AdminConfig.getid("/Node:"+nodeName+"/")

if (nodeId==""):
    validationError("Node "+ nodeName + "doesn't exist")

servers = AdminConfig.list("Server", nodeId)
serversList = servers.split(lineSeparator)
serverName =  AdminConfig.showAttribute(serversList[0], "name")
serverId=AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/")

if (serverId==""):
    validationError("Server "+ serverName + " doesn't exist")

#finding the server id & name
servers = AdminConfig.list("Server", nodeId)
serversList = servers.split(lineSeparator)
serverId=AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/")
#finding scope
scope = "/Node:"+nodeName+"/Server:"+serverName+"/"
scopeId = serverId

ds = findDataSource(jndiName,scopeId,scope)

if(ds != "") :
    print ""
    print "Removing DSN configuration for WICPDB ..."
    AdminConfig.remove(ds)
    print "Done"


AdminConfig.save()