@rem  Licensed Materials - Property of IBM
@rem  5724-R31, 5655-S30
@rem  (C) Copyright IBM Corporation 2009,2010,2011. All Rights Reserved.
@rem  US Government Users Restricted Rights- Use, duplication or disclosure
@rem  restricted by GSA ADP Schedule Contract with IBM Corp.


@echo off
setlocal

@rem change cmd locale to english
chcp 437

@rem set variables
set CURRENT_DIR=%cd%
set SCRIPT_DIR=%~dp0%
echo.%CURRENT_DIR%
cd /d %SCRIPT_DIR%
echo.%SCRIPT_DIR%

@rem get user input parameters
FOR /F "eol=; tokens=2,2 delims==" %%i IN ('findstr /i "WPS_HOME" config.properties') DO set WPS_HOME=%%i
echo %WPS_HOME%
FOR /F "eol=; tokens=2,2 delims==" %%i IN ('findstr /i "HOSTNAME" config.properties') DO set HOSTNAME=%%i
echo %HOSTNAME%
FOR /F "eol=; tokens=2,2 delims==" %%i IN ('findstr /i "SOAPPORT" config.properties') DO set SOAPPORT=%%i
echo %SOAPPORT%
FOR /F "eol=; tokens=2,2 delims==" %%i IN ('findstr /i "HOSTPORT" config.properties') DO set HOSTPORT=%%i
echo %HOSTPORT%
FOR /F "eol=; tokens=2,2 delims==" %%i IN ('findstr /i "user" config.properties') DO set user=%%i
echo %user%
FOR /F "eol=; tokens=2,2 delims==" %%i IN ('findstr /i "password" config.properties') DO set password=%%i
echo %password%
FOR /F "eol=; tokens=2,2 delims==" %%i IN ('findstr /i "profileName" config.properties') DO set profileName=%%i
echo %profileName%
FOR /F "eol=; tokens=2,2 delims==" %%i IN ('findstr /i "cellName" config.properties') DO set cellName=%%i
echo %cellName%
FOR /F "eol=; tokens=2,2 delims==" %%i IN ('findstr /i "profilePath" config.properties') DO set profilePath=%%i
echo %profilePath%
FOR /F "eol=; tokens=2,2 delims==" %%i IN ('findstr /i "nodeName" config.properties') DO set nodeName=%%i
echo %nodeName%
FOR /F "eol=; tokens=2,2 delims==" %%i IN ('findstr /i "DB2USR" config.properties') DO set DB2USR=%%i
echo %DB2USR%
FOR /F "eol=; tokens=2,2 delims==" %%i IN ('findstr /i "DB2PASSWRD" config.properties') DO set DB2PASSWRD=%%i
echo %DB2PASSWRD%

@rem start Telecom Monitor Model installation
@echo ************************************************
@echo             Install Telecom Reference Impl APP
@echo ************************************************
@echo Installing Telecom Monitor Model ...

cd /d %SCRIPT_DIR%

echo Copying the library files..
copy ..\runtime\shared-libraries\. %WPS_HOME%\lib\ext /Y
mkdir %profilePath%/telecom-shared-libraries
copy ..\runtime\shared-libraries\. %profilePath%\telecom-shared-libraries /Y

@rem Start creating WebSphere variable, shared library and configuring classloader
@echo ************************************************
@echo		  
@echo             Configure WebSphere variable
@echo             Configure Shared Library
@echo             Configure Classloader
@echo 
@echo ************************************************
call %WPS_HOME%\bin\wsadmin -conntype SOAP -host %HOSTNAME% -port %SOAPPORT% -user %user% -password %password% -f wbVariable.py -nodeName %nodeName% -cellName %cellName% -tracefile ./logs/telecom_install.trace -appendtrace true
@echo

echo Shutting down the server..
call %profilePath%\bin\stopServer.bat server1 -username %user% -password %password%
echo Starting the server now..
call %profilePath%\bin\startServer.bat server1

@rem Monitor detection 
call %WPS_HOME%\java\bin\java -jar XMLParser.jar %WPS_HOME%\properties\profileRegistry.xml %profileName% > tmpfile
set /p RV= < tmpFile 
del tmpFile 
if "%RV%"=="true" (
	echo Monitor detection is done
	call %WPS_HOME%\bin\wsadmin -conntype SOAP -host %HOSTNAME% -port %SOAPPORT% -user %user% -password %password% -wsadmin_classpath %WPS_HOME%\plugins\com.ibm.wbimonitor.lifecycle.spi.jar -f installtelecomMonears.py -nodeName %nodeName% -cellName %cellName% -tracefile ./logs/telecom_install.trace -appendtrace true
	) else (
	echo Monitor not found
	call %WPS_HOME%\bin\wsadmin -conntype SOAP -host %HOSTNAME% -port %SOAPPORT% -user %user% -password %password% -f installTelecomEars.py -nodeName %nodeName% -cellName %cellName% -tracefile ./logs/telecom_install.trace -appendtrace true
	)

@rem updating the business space props
echo Business Space Config started
call %WPS_HOME%\java\bin\java -jar com.ibm.wicp.bspace.prop.update.jar %profilePath%\BusinessSpace\%nodeName%\server1\mm.runtime.prof\config\ConfigService.properties  com.ibm.bspace.login.style better-telecom
call %WPS_HOME%\bin\wsadmin -conntype SOAP -host %HOSTNAME% -port %SOAPPORT% -user %user% -password %password% -f updateBSpaceProp.py  -nodeName %nodeName% -profilePath %profilePath% -serverName server1 -tracefile ./logs/telecom_install.trace -appendtrace true
echo Business Space Conguration is done.



cd /d %SCRIPT_DIR%
@rem calling log status checker
call %WPS_HOME%\java\bin\java -jar ../../../lib/com.ibm.wicp.install.error.util.jar install ./logs/telecom_install.log ./logs/telecom_install.trace
@echo.
@echo.
goto QUITNOW

if  "%ERRORLEVEL%" NEQ "0" goto MONITORMODELSTARTINFO


@echo ************************************************
@echo             INSTALLATION SUCCESSFUL.
@echo ************************************************
goto QUITNOW

:REPORTERROR
@echo INSTALLATION FAILURE: ERROR CODE=%ERRORLEVEL%: The installation of the Telecom Monitor Model failed.
@echo ************************************************
@echo             INSTALLATION FAILED.
@echo ************************************************
goto QUITNOW

:MONITORMODELSTARTINFO
@echo *********************************************************************************************
@echo *********************************************************************************************
@echo INSTALLATION SUCCESSFUL.(Please ensure that all the Applications within WPS Administration console are in started state.)
@echo *********************************************************************************************
@echo *********************************************************************************************
goto QUITNOW


:QUITNOW
cd %CURRENT_DIR%
@echo on